local Component = require("entities.component")
local AnimFacing = Component:extend("Animation Facing Component")

function AnimFacing:onAttach()
	local entity = self.entity

	entity.face = self.face
end

function AnimFacing:face(facing)
	if(self.type) then
		if(self.faces[facing] and self.faces[facing][self.type]) then
			self.animation = self.faces[facing][self.type]
		end
	else
		if(self.faces[facing]) then
			self.animation = self.faces[facing]
		end
	end
end

return AnimFacing
