-- Global classes
Class = require("libs.class.30log")
GS = require("libs.hump.gamestate")
Beholder = require("libs.observer.beholder")
Anim8 = require("libs.image.anim8")
-- ProFi = require("libs.profiling.ProFi")

-- Global vars
load = nil
options = nil

local RH = require("utils.resourcehandler")
local Options = require("utils.options")

function love.load(arg)
	-- ProFi:start()
	local currentDir = unpack(arg)

	load = RH:new("assets", { images = "images", fonts = "fonts" })
	options = Options:new()

	GS.registerEvents()
	GS.switch(require("states.init-game"))
end

-- TODO: (+ done, - todo)
-- + Entity-Entity collision
-- + Change init-game to reflect addEntity
-- + Add in bombs
-- + Add in stationary other players
-- + Redo movement thing
-- + Add in raycast to map / split + add reference
-- + Add in spawner to map / split + add reference
-- + Clear is array[k] = nil for all k
-- + Have raycast and spawner work
-- + Sprite draw culling
-- + Redo unit and bomb, merge redundant vars to entity
-- + Have bomb placement as a component
-- + Fix entity-entity collision
-- + Fix movement for hitboxes
-- + Have onAttach() to parts
-- + Move death to a module
-- + functions binded using onAttach() should use self instead of entity
-- + Sprite culling would refer to the FOV setting
-- + Fix sprite draw distance
-- + Remove minimap
-- + Have bombs destroy soft walls
-- - Fix bomb placement through walls (fix with raycast!)
-- - Mouse Look
-- + functions with onAttach() should return modifications to default in onDetach()
-- + Have owner only visible sprites
-- + Rework explosion logic
-- - Acceleration based movement
-- + Fix explosion logic
-- - Floor "tiles" or "grid"?

-- JUICE:
-- + View bobbing
-- + Bomb Ghost aka. placement guide
-- - Better floorcasting calculations
-- + Delayed spawing
-- - Shadow casting
-- + Death Animation (implemented but needs better angle)
-- + Better explosions
-- + Soft wall death (4 entities?)
-- + Stage 1 tiles
-- - Rework explosion, to be spatially correct?
-- - Screen shake if nearby explosions?

-- Credits? Credits.
-- Raycaster, Spritecast and floorcast code heavily references
-- jasoco's wolfen3D engine thing and
-- http://dev.opera.com/articles/view/creating-pseudo-3d-games-with-html-5-can-1/
-- and
-- http://permadi.com/1996/05/ray-casting-tutorial-table-of-contents/
