local Component = require("entities.component")
local AnimDeath = Component:extend("Animation Death Component")

function AnimDeath:init()
	self.duration = 0
end

function AnimDeath:update(dt)
	local entity = self.entity

	self.duration = self.duration + dt
	if(entity.animation and self.duration >= entity.animation.totalDuration) then
		entity.alive = false
	end
end

return AnimDeath
