local Component = require("entities.component")
local MoveAnim = Component:extend("Movement Animation Component")

function MoveAnim:update(dt)
	local entity = self.entity
	if(entity.animation) then
		if(entity.speed:len2() > 0) then
			entity.animation:resume()
		else
			entity.animation:pauseAtStart()
		end
	end
end

return MoveAnim
